unit DataServer_TLB;

// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// PASTLWTR : $Revision:   1.79  $
// File generated on 26/10/99 16.21.28 from Type Library described below.

// ************************************************************************ //
// Type Lib: D:\Documenti\WebBroker\Code\DataServer\DataServer.tlb (1)
// IID\LCID: {D616CDC8-8BB0-11D3-9A42-00105AF80DD9}\0
// Helpfile: 
// DepndLst: 
//   (1) v2.0 stdole, (D:\WINDOWS\SYSTEM\STDOLE2.TLB)
//   (2) v4.0 StdVCL, (D:\WINDOWS\SYSTEM\STDVCL40.DLL)
//   (3) v1.0 Midas, (D:\WINDOWS\SYSTEM\MIDAS.DLL)
// ************************************************************************ //
interface

uses Windows, ActiveX, Classes, Graphics, OleServer, OleCtrls, StdVCL, 
  MIDAS;

// *********************************************************************//
// GUIDS declared in the TypeLibrary. Following prefixes are used:        
//   Type Libraries     : LIBID_xxxx                                      
//   CoClasses          : CLASS_xxxx                                      
//   DISPInterfaces     : DIID_xxxx                                       
//   Non-DISP interfaces: IID_xxxx                                        
// *********************************************************************//
const
  // TypeLibrary Major and minor versions
  DataServerMajorVersion = 1;
  DataServerMinorVersion = 0;

  LIBID_DataServer: TGUID = '{D616CDC8-8BB0-11D3-9A42-00105AF80DD9}';

  IID_IDataServer: TGUID = '{D616CDC9-8BB0-11D3-9A42-00105AF80DD9}';
  CLASS_dmDataServer: TGUID = '{D616CDCB-8BB0-11D3-9A42-00105AF80DD9}';
type

// *********************************************************************//
// Forward declaration of types defined in TypeLibrary                    
// *********************************************************************//
  IDataServer = interface;
  IDataServerDisp = dispinterface;

// *********************************************************************//
// Declaration of CoClasses defined in Type Library                       
// (NOTE: Here we map each CoClass to its Default Interface)              
// *********************************************************************//
  dmDataServer = IDataServer;


// *********************************************************************//
// Interface: IDataServer
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D616CDC9-8BB0-11D3-9A42-00105AF80DD9}
// *********************************************************************//
  IDataServer = interface(IAppServer)
    ['{D616CDC9-8BB0-11D3-9A42-00105AF80DD9}']
  end;

// *********************************************************************//
// DispIntf:  IDataServerDisp
// Flags:     (4416) Dual OleAutomation Dispatchable
// GUID:      {D616CDC9-8BB0-11D3-9A42-00105AF80DD9}
// *********************************************************************//
  IDataServerDisp = dispinterface
    ['{D616CDC9-8BB0-11D3-9A42-00105AF80DD9}']
    function  AS_ApplyUpdates(const ProviderName: WideString; Delta: OleVariant; 
                              MaxErrors: Integer; out ErrorCount: Integer; var OwnerData: OleVariant): OleVariant; dispid 20000000;
    function  AS_GetRecords(const ProviderName: WideString; Count: Integer; out RecsOut: Integer; 
                            Options: Integer; const CommandText: WideString; 
                            var Params: OleVariant; var OwnerData: OleVariant): OleVariant; dispid 20000001;
    function  AS_DataRequest(const ProviderName: WideString; Data: OleVariant): OleVariant; dispid 20000002;
    function  AS_GetProviderNames: OleVariant; dispid 20000003;
    function  AS_GetParams(const ProviderName: WideString; var OwnerData: OleVariant): OleVariant; dispid 20000004;
    function  AS_RowRequest(const ProviderName: WideString; Row: OleVariant; RequestType: Integer; 
                            var OwnerData: OleVariant): OleVariant; dispid 20000005;
    procedure AS_Execute(const ProviderName: WideString; const CommandText: WideString; 
                         var Params: OleVariant; var OwnerData: OleVariant); dispid 20000006;
  end;

// *********************************************************************//
// The Class CodmDataServer provides a Create and CreateRemote method to          
// create instances of the default interface IDataServer exposed by              
// the CoClass dmDataServer. The functions are intended to be used by             
// clients wishing to automate the CoClass objects exposed by the         
// server of this typelibrary.                                            
// *********************************************************************//
  CodmDataServer = class
    class function Create: IDataServer;
    class function CreateRemote(const MachineName: string): IDataServer;
  end;


// *********************************************************************//
// OLE Server Proxy class declaration
// Server Object    : TdmDataServer
// Help String      : DataServer Object
// Default Interface: IDataServer
// Def. Intf. DISP? : No
// Event   Interface: 
// TypeFlags        : (2) CanCreate
// *********************************************************************//
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  TdmDataServerProperties= class;
{$ENDIF}
  TdmDataServer = class(TOleServer)
  private
    FIntf:        IDataServer;
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    FProps:       TdmDataServerProperties;
    function      GetServerProperties: TdmDataServerProperties;
{$ENDIF}
    function      GetDefaultInterface: IDataServer;
  protected
    procedure InitServerData; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    procedure Connect; override;
    procedure ConnectTo(svrIntf: IDataServer);
    procedure Disconnect; override;
    function  AS_ApplyUpdates(const ProviderName: WideString; Delta: OleVariant; 
                              MaxErrors: Integer; out ErrorCount: Integer; var OwnerData: OleVariant): OleVariant;
    function  AS_GetRecords(const ProviderName: WideString; Count: Integer; out RecsOut: Integer; 
                            Options: Integer; const CommandText: WideString; 
                            var Params: OleVariant; var OwnerData: OleVariant): OleVariant;
    function  AS_DataRequest(const ProviderName: WideString; Data: OleVariant): OleVariant;
    function  AS_GetProviderNames: OleVariant;
    function  AS_GetParams(const ProviderName: WideString; var OwnerData: OleVariant): OleVariant;
    function  AS_RowRequest(const ProviderName: WideString; Row: OleVariant; RequestType: Integer; 
                            var OwnerData: OleVariant): OleVariant;
    procedure AS_Execute(const ProviderName: WideString; const CommandText: WideString; 
                         var Params: OleVariant; var OwnerData: OleVariant);
    property  DefaultInterface: IDataServer read GetDefaultInterface;
  published
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
    property Server: TdmDataServerProperties read GetServerProperties;
{$ENDIF}
  end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
// *********************************************************************//
// OLE Server Properties Proxy Class
// Server Object    : TdmDataServer
// (This object is used by the IDE's Property Inspector to allow editing
//  of the properties of this server)
// *********************************************************************//
 TdmDataServerProperties = class(TPersistent)
  private
    FServer:    TdmDataServer;
    function    GetDefaultInterface: IDataServer;
    constructor Create(AServer: TdmDataServer);
  protected
  public
    property DefaultInterface: IDataServer read GetDefaultInterface;
  published
  end;
{$ENDIF}


procedure Register;

implementation

uses ComObj;

class function CodmDataServer.Create: IDataServer;
begin
  Result := CreateComObject(CLASS_dmDataServer) as IDataServer;
end;

class function CodmDataServer.CreateRemote(const MachineName: string): IDataServer;
begin
  Result := CreateRemoteComObject(MachineName, CLASS_dmDataServer) as IDataServer;
end;

procedure TdmDataServer.InitServerData;
const
  CServerData: TServerData = (
    ClassID:   '{D616CDCB-8BB0-11D3-9A42-00105AF80DD9}';
    IntfIID:   '{D616CDC9-8BB0-11D3-9A42-00105AF80DD9}';
    EventIID:  '';
    LicenseKey: nil;
    Version: 500);
begin
  ServerData := @CServerData;
end;

procedure TdmDataServer.Connect;
var
  punk: IUnknown;
begin
  if FIntf = nil then
  begin
    punk := GetServer;
    Fintf:= punk as IDataServer;
  end;
end;

procedure TdmDataServer.ConnectTo(svrIntf: IDataServer);
begin
  Disconnect;
  FIntf := svrIntf;
end;

procedure TdmDataServer.DisConnect;
begin
  if Fintf <> nil then
  begin
    FIntf := nil;
  end;
end;

function TdmDataServer.GetDefaultInterface: IDataServer;
begin
  if FIntf = nil then
    Connect;
  Assert(FIntf <> nil, 'DefaultInterface is NULL. Component is not connected to Server. You must call ''Connect'' or ''ConnectTo'' before this operation');
  Result := FIntf;
end;

constructor TdmDataServer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps := TdmDataServerProperties.Create(Self);
{$ENDIF}
end;

destructor TdmDataServer.Destroy;
begin
{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
  FProps.Free;
{$ENDIF}
  inherited Destroy;
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
function TdmDataServer.GetServerProperties: TdmDataServerProperties;
begin
  Result := FProps;
end;
{$ENDIF}

function  TdmDataServer.AS_ApplyUpdates(const ProviderName: WideString; Delta: OleVariant; 
                                        MaxErrors: Integer; out ErrorCount: Integer; 
                                        var OwnerData: OleVariant): OleVariant;
begin
  Result := DefaultInterface.AS_ApplyUpdates(ProviderName, Delta, MaxErrors, ErrorCount, OwnerData);
end;

function  TdmDataServer.AS_GetRecords(const ProviderName: WideString; Count: Integer; 
                                      out RecsOut: Integer; Options: Integer; 
                                      const CommandText: WideString; var Params: OleVariant; 
                                      var OwnerData: OleVariant): OleVariant;
begin
  Result := DefaultInterface.AS_GetRecords(ProviderName, Count, RecsOut, Options, CommandText, 
                                           Params, OwnerData);
end;

function  TdmDataServer.AS_DataRequest(const ProviderName: WideString; Data: OleVariant): OleVariant;
begin
  Result := DefaultInterface.AS_DataRequest(ProviderName, Data);
end;

function  TdmDataServer.AS_GetProviderNames: OleVariant;
begin
  Result := DefaultInterface.AS_GetProviderNames;
end;

function  TdmDataServer.AS_GetParams(const ProviderName: WideString; var OwnerData: OleVariant): OleVariant;
begin
  Result := DefaultInterface.AS_GetParams(ProviderName, OwnerData);
end;

function  TdmDataServer.AS_RowRequest(const ProviderName: WideString; Row: OleVariant; 
                                      RequestType: Integer; var OwnerData: OleVariant): OleVariant;
begin
  Result := DefaultInterface.AS_RowRequest(ProviderName, Row, RequestType, OwnerData);
end;

procedure TdmDataServer.AS_Execute(const ProviderName: WideString; const CommandText: WideString; 
                                   var Params: OleVariant; var OwnerData: OleVariant);
begin
  DefaultInterface.AS_Execute(ProviderName, CommandText, Params, OwnerData);
end;

{$IFDEF LIVE_SERVER_AT_DESIGN_TIME}
constructor TdmDataServerProperties.Create(AServer: TdmDataServer);
begin
  inherited Create;
  FServer := AServer;
end;

function TdmDataServerProperties.GetDefaultInterface: IDataServer;
begin
  Result := FServer.DefaultInterface;
end;

{$ENDIF}

procedure Register;
begin
  RegisterComponents('Servers',[TdmDataServer]);
end;

end.
